<template>
    <div>
        <v-card elevation="1" class="admin-content">
            <v-card-title>
                {{title ? title : 'Liste des professionnels'}}
                <v-divider class="ml-4 mr-2" inset vertical></v-divider>
                <v-col cols="12" md="4">
                    <v-text-field
                        v-model="search"
                        append-icon="mdi-magnify"
                        label="Rechercher un professionnel"
                        single-line
                        hide-details
                    />
                </v-col>
                <v-divider class="ml-4 mr-6" inset vertical></v-divider>
                <v-btn
                    color="secondary"
                    @click="dialogNewPro = true"
                >
                    <v-icon left>
                        mdi-plus
                    </v-icon>
                    Ajouter
                </v-btn>
                <v-dialog
                    v-model="dialogNewPro"
                    max-width="500px"
                >
                    <v-card>
                        <v-card-title>
                            <span class="headline">Nouveau professionnel</span>
                        </v-card-title>
                         <v-form
                            v-model="isFormValid"
                            ref="newProForm"
                            @submit.prevent="submitNewProForm"
                        >
                        <v-card-text>
                            <v-container>
                                <v-row>
                                    <v-col cols="12" sm="6">
                                        <v-select
                                            v-model="newPro.title"
                                            :items="titleSelectItems"
                                            label="Titre"
                                        ></v-select>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newPro.firstName"
                                            label="Nom"
                                            :rules="[$utils.rules.required]"
                                            :counter="32"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newPro.lastName"
                                            label="Prénom"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-select
                                            v-model="newPro.gender"
                                            :items="genderSelectItems"
                                            label="Gendre"
                                        ></v-select>
                                    </v-col>
                                    <v-col cols="12" sm="12">
                                        <v-text-field
                                            v-model="newPro.email"
                                            label="Adresse e-mail"
                                            :rules="[$utils.rules.required, $utils.rules.email]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newPro.dob"
                                            type="date"
                                            label="Date de naissance"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newPro.plainPassword"
                                            label="Mot de passe"
                                            type="password"
                                            :rules="[$utils.rules.required]"
                                            :counter="250"
                                        ></v-text-field>
                                    </v-col>
                                    <v-col cols="12" sm="6">
                                        <v-text-field
                                            v-model="newPro.phoneNumber"
                                            label="Numéro de téléphone"
                                            :rules="[$utils.rules.required]"
                                            :counter="64"
                                        ></v-text-field>
                                    </v-col>
                                </v-row>
                            </v-container>
                        </v-card-text>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn
                                color="blue darken-1"
                                text
                                @click="dialogNewPro = false"
                            >
                                Annuler
                            </v-btn>
                            <v-btn
                                color="blue darken-1"
                                type="submit"
                                :disabled="!isFormValid"
                                text
                            >
                                Ajouter
                            </v-btn>
                        </v-card-actions>
                        </v-form>
                    </v-card>
                </v-dialog>
                <v-dialog v-model="dialogDelete" max-width="500px">
                    <v-card>
                        <v-card-title class="headline">Etes-vous sûr de vouloir supprimer ?</v-card-title>
                        <v-card-actions>
                            <v-spacer></v-spacer>
                            <v-btn color="blue darken-1" text @click="closeDelete">Annuler</v-btn>
                            <v-btn color="blue darken-1" text @click="confirmDeleteProDialog">OK</v-btn>
                            <v-spacer></v-spacer>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-card-title>
            <v-data-table
                :headers="proTableHeaders"
                :items="prosOfOffice ? prosOfOffice : getPros"
                :search="search"
                :items-per-page="10"
                :loading="loading"
                no-results-text="Aucun résultat n'a été trouvé pour votre recherche"	
                no-data-text="Il n'y a pas de données disponibles"
                loading-text="Les données sont en cours de chargement"
            >   
                <template v-slot:[`item.enabled`]="{item}">
                    <v-chip
                        :color="getEnabledWithColor(item.enabled).color"
                        dark
                        class="font-weight-bold"
                    >
                        {{ getEnabledWithColor(item.enabled).enabled }}
                    </v-chip>
                </template>
                <template v-slot:[`item.actions`]="{item}">
                    <v-icon
                        class="mr-2"
                        @click="editPro(item.id)"
                    >
                        mdi-pencil
                    </v-icon>
                </template>
            </v-data-table>
        </v-card>
        <v-snackbar
            v-model="prosSnackbar"
            :timeout="3000"
            :color="snackbarColor"
        >
            {{snackbarMessage}}
            <template v-slot:action="{ attrs }">
                <v-btn
                    color="white"
                    text
                    v-bind="attrs"
                    @click="prosSnackbar = false"
                >
                    Fermer
                </v-btn>
            </template>
        </v-snackbar>
    </div>
</template>

<script>
import {mapActions, mapGetters} from 'vuex';

export default {
    name: 'Pros',
    props: ['prosOfOffice', 'title'],
    data: () => ({
        search: '',
        dialogNewPro: false,
        dialogDelete: false,
        currentProId: null,
        prosSnackbar: false,
        snackbarMessage: '',
        snackbarColor: '',
        isFormValid: true,
        loading: false,
        newPro: {
            'type': 'pro',
            title: '',
            email: '',
            plainPassword: '',
            gender: '',
            firstName: '',
            lastName: '',
            dob: '',
            enabled: 0,
            phoneNumber: ''
        },
        titleSelectItems: ['Dr.', 'Me.'],
        genderSelectItems: [
            {text: 'Homme', value: 'men'},
            {text: 'Femme', value: 'women'},
            {text: 'Autre', value: 'other'}
        ],
    }),
    methods: {
        ...mapActions(['loadPros', 'deletePro', 'addPro']),
        editPro(proId) {
            this.$router.push({name: 'ProDetail', params: {proId}})
        },
        deleteProDialog(proId) {
            this.dialogDelete = true
            this.currentProId = proId;
        },
        closeDelete() {
            this.dialogDelete = false;
            this.currentProId = null;
        },
        confirmDeleteProDialog() {
            this.deletePro(this.currentProId)
                .then(() => {
                    this.dialogDelete = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le professionnel a été supprimé avec succès';
                    this.prosSnackbar = true;
                })
                .catch((error) => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = error;
                    this.prosSnackbar = true;
                });
        },
        submitNewProForm() {
            this.addPro(this.newPro)
                .then(() => {
                    this.dialogNewPro = false;
                    this.snackbarColor = 'green';
                    this.snackbarMessage = 'Le nouveau professionnel a été ajouté avec succès';
                    this.prosSnackbar = true;
                    this.$refs.newProForm.reset();
                })
                .catch(() => {
                    this.snackbarColor = 'red';
                    this.snackbarMessage = this.getCrudError;
                    this.prosSnackbar = true;
                });
        },
        getEnabledWithColor(enabled) {
            if (enabled === 0) return {color: 'orange', enabled: 'En attente'}
            else if (enabled === 1) return {color: 'green', enabled: 'Vérifié'}
        },
        loadingPros() {
            if (this.getPros === undefined || this.getPros.length === 0) {
                this.loading = true;
                this.loadPros()
                    .then(() => this.loading = false);
            }
        }
    },
    computed: {
        proTableHeaders() {
            return [
                {text: 'Nom', align: 'start', value: 'firstName'},
                {text: 'Prénom', value: 'lastName'},
                {text: 'Job', value: 'job'},
                {text: 'Statut', value: 'enabled'},
                {text: 'Téléphone', value: 'phoneNumber'},
                {text: 'Actions', value: 'actions', sortable: false},
            ]
        },
        ...mapGetters(['getPros', 'getCrudError'])
    },
    mounted() {
        this.loadingPros();
    }
}
</script>